<?php
namespace Util;

class PostGroupConditions {

    public static function filter($returnData, $postConditions){
        $filteredData = [];
        foreach($returnData as $data){
            if(self::evalCondition($postConditions, $data)){
                $filteredData[] = $data;
            }
        }
        return $filteredData;
    }

    protected static function evalCondition($condition, $data){
        if(is_array($condition)){
            $firstValue = !is_array($condition["firstValue"]) && !empty($data[$condition["firstValue"]]) ? $data[$condition["firstValue"]] : $condition["firstValue"];
            $firstValue = self::evalCondition($firstValue, $data);
            $secondValue = !is_array($condition["secondValue"]) && !empty($data[$condition["secondValue"]]) ? $data[$condition["secondValue"]] : $condition["secondValue"];
            $secondValue = self::evalCondition($secondValue, $data);
            $operator = $condition["operator"];
            switch($operator){
                default:
                case "==":
                    return $firstValue == $secondValue;
                break;
                case "!=":
                    return $firstValue != $secondValue;
                break;
                case ">":
                    return $firstValue > $secondValue;
                break;
                case "<":
                    return $firstValue < $secondValue;
                break;
                case ">=":
                    return $firstValue >= $secondValue;
                break;
                case "<=":
                    return $firstValue <= $secondValue;
                break;
                case "+":
                    return $firstValue + $secondValue;
                break;
                case "-":
                    return $firstValue - $secondValue;
                break;
                case "*":
                    return $firstValue * $secondValue;
                break;
                case "/":
                    return $firstValue / $secondValue;
                break;
            }
        }
        return $condition;
    }

}